import os
from constants.constants import TEST


class FileListParser:
    files = []
    exe_path = None
    vm_swap = None
    vm_rss = None

    def get_vm_info(self, pid):
        status = os.popen("cat /proc/%s/status 2>/dev/null" % pid)
        status_output = status.read().split("\n")
        for line in status_output:
            if "VmSwap" in line:
                self.vm_swap = int(line.split()[1]) * 1024
            if "VmRSS" in line:
                self.vm_rss = int(line.split()[1]) * 1024

    def list_files(self, pid):
        list_open_files = os.popen("ls -l /proc/%s/fd 2>/dev/null" % pid)
        exe_path = os.popen("readlink /proc/%s/exe 2>/dev/null" % pid)
        self.get_vm_info(pid)
        open_files = list_open_files.read().split("\n")
        self.files = [file.split(" -> ")[1] for file in open_files if "/" in file]
        self.exe_path = exe_path.read().strip("\n")
        exe_path.close()
        list_open_files.close()

    def open_test_file(self):
        with open("../test_files/dc_lsfd", "r") as job_file:
            self.files = []
            job_file.readline()
            job = job_file.readline()
            while job:
                file = job.split(" -> ")[1].strip("\n")
                if "/" in file:
                    self.files.append(file)
                job = job_file.readline()
                self.exe_path = "/var/tmp"
                self.vm_swap = "53 kB"
                self.vm_rss = "2048 kB"

    def add_open_files_to_process(self, process):
        if not TEST:
            self.list_files(process["pid"])
        else:
            self.open_test_file()
        process["open_files"] = self.files
        process["exe_path"] = self.exe_path
        process["vm_swap_bytes"] = self.vm_swap
        process["vm_rss_bytes"] = self.vm_rss
